#! /usr/bin/env python

from __future__ import print_function
import subprocess, os, argparse, glob, sys

pyversion = sys.version_info[0]
def mydecode(b):
    return b.decode('utf8')
    
versions = [
    "fib_seq",
    "fib_sections"
]

parser = argparse.ArgumentParser()
parser.add_argument('-t', type=int, default=1)
parser.add_argument('-n', type=int, default=48)
args = parser.parse_args()

err = 0
for v in versions:
    e = os.environ.copy()
    if v == 'fib_sections':
        e['OMP_NUM_THREADS'] = str(args.t)
    
    print("\n___________________________", file=sys.stderr) 
    print(v, file=sys.stderr) 

    cmd = [os.path.join("install", v),
                        "--n", str(args.n)
                        ]
    s = mydecode(subprocess.check_output(cmd, stderr=subprocess.STDOUT, env=e))
    print(s, end='', file=sys.stderr)
    r0 = s.find('CPU time : ')
    r1 = s.find(' s', r0)
    t = float(s[r0 + 11:r1])
    if v == 'fib_seq':
        t0 = t
    else:
        print ("\n speedup = {:.2f}\n".format(t0/t), file=sys.stderr)
