#! /usr/bin/env python
# -*- coding: utf-8 -*-


import os, sys, argparse, time, glob
from subprocess import *
from util import *

for f in glob.glob('error*'):
  os.remove(f)

for f in glob.glob('output*'):
  os.remove(f)

parser = argparse.ArgumentParser()
parser.add_argument('-t', '--threads', type=int, default=1)
parser.add_argument('-n', type=int, default=48)
parser.add_argument('-l', type=int, default=6)
parser.add_argument('rest', nargs=argparse.REMAINDER)
args = parser.parse_args()

job = '''#!/bin/bash

#SBATCH --job-name=Ex3_OpenMP
#SBATCH --output=output.txt
#SBATCH --error=output.txt

@ACC@

#SBATCH --ntasks=1
#SBATCH --cpus-per-task=@THREADS@
#SBATCH --time=00:01:00

## load modules
module load gcc/10.2.0

python3 run.py -n @N@ -t @THREADS@
'''

s = job
s = s.replace("@N@", str(args.n))
s = s.replace("@THREADS@", str(args.threads))
s = s.replace("@ACC@", queue())

with open('job.sh', 'w') as f:
   f.write(s)

call(['sbatch', 'job.sh'])
