#! /usr/bin/env python3
# -*- coding: utf-8 -*-


import os, sys, argparse, time, glob
from subprocess import *
from util import *

for f in glob.glob('output*'):
  os.remove(f)

job = '''#!/bin/bash

#SBATCH --job-name=Ex3_OpenMP
#SBATCH --output=output.txt
#SBATCH --error=output.txt

@ACC@

#SBATCH --ntasks=1
#SBATCH --time=00:01:00

## load modules
module load cmake/3.26.3
module load gcc/10.2.0

python3 -u build.py
'''

s = job
s = s.replace("@ACC@", queue())

with open('job.sh', 'w') as f:
   f.write(s)

call(['sbatch', 'job.sh'])
