#! /usr/bin/env python
# -*- coding: utf-8 -*-


import os, sys, argparse, time, glob
from subprocess import *
from util import *

for f in glob.glob('error*'):
  os.remove(f)

for f in glob.glob('output*'):
  os.remove(f)

job = '''#!/bin/bash

#SBATCH --job-name=Ex3_OpenMP
#SBATCH --output=output.txt
#SBATCH --error=output.txt

@ACC@

#SBATCH --ntasks=1
#SBATCH --time=00:01:00

## load modules
module load cmake/3.26.3
module load intel_compiler/19.1.3.304

TBB_ROOT=`pwd`/local/tbb
cmake -S src -B build -DCMAKE_INSTALL_PREFIX=install \
   -DTBB_INCLUDE_DIR=${TBB_ROOT}/include/oneapi \
   -DTBB_LIBRARY_DIR=${TBB_ROOT}/lib64
make -C build install
'''

s = job
s = s.replace("@ACC@", queue())

with open('job.sh', 'w') as f:
   f.write(s)

call(['sbatch', 'job.sh'])
